// Code generated by tygo. DO NOT EDIT.
import * as MautrixID from "../id/index.ts"
import * as MautrixBridgeV2 from "../bridgev2/index.ts"
import * as MautrixEvent from "../event/index.ts"
import * as MautrixBridgeV2Commands from "../bridgev2/commands/index.ts"
import * as MautrixBridgeV2NetworkID from "../bridgev2/networkid/index.ts"
import * as MautrixBridgeStatus from "../bridge/status/index.ts"
import * as BeeperSDKBridgesTypes from "../../../../github.com/beeper/beeper-client-sdk/pkg/bridges/types/index.ts"
//////////
// source: accountdata.go

/**
 * TagEventContent represents the content of a m.tag room account data event.
 * https://spec.matrix.org/v1.2/client-server-api/#mtag
 */
export interface TagEventContent {
  tags: Tags;
}
export type Tags = { [key: RoomTag]: TagMetadata};
export type RoomTag = string;
export const RoomTagFavourite: RoomTag = "m.favourite";
export const RoomTagLowPriority: RoomTag = "m.lowpriority";
export const RoomTagServerNotice: RoomTag = "m.server_notice";
/**
 * Deprecated: type alias
 */
export type Tag = TagMetadata;
export interface TagMetadata {
  order?: any /* json.Number */;
  'fi.mau.double_puppet_source'?: string;
}
/**
 * DirectChatsEventContent represents the content of a m.direct account data event.
 * https://spec.matrix.org/v1.2/client-server-api/#mdirect
 */
export type DirectChatsEventContent = { [key: MautrixID.UserID]: MautrixID.RoomID[]};
/**
 * FullyReadEventContent represents the content of a m.fully_read account data event.
 * https://spec.matrix.org/v1.2/client-server-api/#mfully_read
 */
export interface FullyReadEventContent {
  event_id: MautrixID.EventID;
}
/**
 * IgnoredUserListEventContent represents the content of a m.ignored_user_list account data event.
 * https://spec.matrix.org/v1.2/client-server-api/#mignored_user_list
 */
export interface IgnoredUserListEventContent {
  ignored_users: { [key: MautrixID.UserID]: IgnoredUser};
}
export interface IgnoredUser {
}
export interface MarkedUnreadEventContent {
  unread: boolean;
}
export interface BeeperMuteEventContent {
  muted_until?: number /* int64 */;
}

//////////
// source: audio.go

export interface MSC1767Audio {
  duration: number /* int */;
  waveform: number /* int */[];
}
export interface MSC3245Voice {
}

//////////
// source: beeper.go

export type MessageStatusReason = string;
export const MessageStatusGenericError: MessageStatusReason = "m.event_not_handled";
export const MessageStatusUnsupported: MessageStatusReason = "com.beeper.unsupported_event";
export const MessageStatusUndecryptable: MessageStatusReason = "com.beeper.undecryptable_event";
export const MessageStatusTooOld: MessageStatusReason = "m.event_too_old";
export const MessageStatusNetworkError: MessageStatusReason = "m.foreign_network_error";
export const MessageStatusNoPermission: MessageStatusReason = "m.no_permission";
export const MessageStatusBridgeUnavailable: MessageStatusReason = "m.bridge_unavailable";
export type MessageStatus = string;
export const MessageStatusSuccess: MessageStatus = "SUCCESS";
export const MessageStatusPending: MessageStatus = "PENDING";
export const MessageStatusRetriable: MessageStatus = "FAIL_RETRIABLE";
export const MessageStatusFail: MessageStatus = "FAIL_PERMANENT";
export interface BeeperMessageStatusEventContent {
  network?: string;
  'm.relates_to': RelatesTo;
  status: MessageStatus;
  reason?: MessageStatusReason;
  /**
   * Deprecated: clients were showing this to users even though they aren't supposed to.
   * Use InternalError for error messages that should be included in bug reports, but not shown in the UI.
   */
  error?: string;
  internal_error?: string;
  message?: string;
  last_retry?: MautrixID.EventID;
  mutate_event_key?: string;
  /**
   * Indicates the set of users to whom the event was delivered. If nil, then
   * the client should not expect delivered status at any later point. If not
   * nil (even if empty), this field indicates which users the event was
   * delivered to.
   */
  delivered_to_users?: MautrixID.UserID[];
}
export interface BeeperRelatesTo {
  event_id?: MautrixID.EventID;
  room_id?: MautrixID.RoomID;
  rel_type?: RelationType;
}
export interface BeeperTranscriptionEventContent {
  'm.text'?: ExtensibleText[];
  'com.beeper.transcription.model'?: string;
  'com.beeper.relates_to'?: BeeperRelatesTo;
}
export interface BeeperRetryMetadata {
  original_event_id: MautrixID.EventID;
  retry_count: number /* int */;
}
export interface BeeperRoomKeyAckEventContent {
  room_id: MautrixID.RoomID;
  session_id: any /* id.SessionID */;
  first_message_index: number /* int */;
}
export interface LinkPreview {
  'og:url'?: string;
  'og:title'?: string;
  'og:type'?: string;
  'og:description'?: string;
  'og:site_name'?: string;
  'og:image'?: MautrixID.ContentURIString;
  'matrix:image:size'?: number /* int */;
  'og:image:width'?: number /* int */;
  'og:image:height'?: number /* int */;
  'og:image:type'?: string;
}
/**
 * BeeperLinkPreview contains the data for a bundled URL preview as specified in MSC4095
 * https://github.com/matrix-org/matrix-spec-proposals/pull/4095
 */
export interface BeeperLinkPreview {
  LinkPreview: LinkPreview;
  matched_url?: string;
  'beeper:image:encryption'?: EncryptedFileInfo;
}
export interface BeeperProfileExtra {
  'com.beeper.bridge.remote_id'?: string;
  'com.beeper.bridge.identifiers'?: string[];
  'com.beeper.bridge.service'?: string;
  'com.beeper.bridge.network'?: string;
  'com.beeper.bridge.is_bridge_bot'?: boolean;
  'com.beeper.bridge.is_network_bot'?: boolean;
}
export interface BeeperPerMessageProfile {
  id: string;
  displayname?: string;
  avatar_url?: MautrixID.ContentURIString;
  avatar_file?: EncryptedFileInfo;
}
export interface BeeperEncodedOrder {
}

//////////
// source: capabilities.go

export interface RoomFeatures {
  id?: string;
  formatting?: FormattingFeatureMap;
  file?: FileFeatureMap;
  max_text_length?: number /* int */;
  location_message?: CapabilitySupportLevel;
  poll?: CapabilitySupportLevel;
  thread?: CapabilitySupportLevel;
  reply?: CapabilitySupportLevel;
  edit?: CapabilitySupportLevel;
  edit_max_count?: number /* int */;
  edit_max_age?: any /* jsontime.Seconds */;
  delete?: CapabilitySupportLevel;
  delete_for_me?: boolean;
  delete_max_age?: any /* jsontime.Seconds */;
  reaction?: CapabilitySupportLevel;
  reaction_count?: number /* int */;
  allowed_reactions?: string[];
  custom_emoji_reactions?: boolean;
  read_receipts?: boolean;
  typing_notifications?: boolean;
  archive?: boolean;
  mark_as_unread?: boolean;
  delete_chat?: boolean;
}
export type FormattingFeatureMap = { [key: FormattingFeature]: CapabilitySupportLevel};
export type FileFeatureMap = { [key: CapabilityMsgType]: FileFeatures | undefined};
export type CapabilityMsgType = MessageType;
/**
 * Message types which are used for event capability signaling, but aren't real values for the msgtype field.
 */
export const CapMsgVoice: CapabilityMsgType = "org.matrix.msc3245.voice";
/**
 * Message types which are used for event capability signaling, but aren't real values for the msgtype field.
 */
export const CapMsgGIF: CapabilityMsgType = "fi.mau.gif";
/**
 * Message types which are used for event capability signaling, but aren't real values for the msgtype field.
 */
export const CapMsgSticker: CapabilityMsgType = "m.sticker";
export type CapabilitySupportLevel = number /* int */;
export const CapLevelRejected: CapabilitySupportLevel = -2; // The feature is unsupported and messages using it will be rejected.
export const CapLevelDropped: CapabilitySupportLevel = -1; // The feature is unsupported and has no fallback. The message will go through, but data may be lost.
export const CapLevelUnsupported: CapabilitySupportLevel = 0; // The feature is unsupported, but may have a fallback.
export const CapLevelPartialSupport: CapabilitySupportLevel = 1; // The feature is partially supported (e.g. it may be converted to a different format).
export const CapLevelFullySupported: CapabilitySupportLevel = 2; // The feature is fully supported and can be safely used.
export type FormattingFeature = string;
export const FmtBold: FormattingFeature = "bold"; // strong, b
export const FmtItalic: FormattingFeature = "italic"; // em, i
export const FmtUnderline: FormattingFeature = "underline"; // u
export const FmtStrikethrough: FormattingFeature = "strikethrough"; // del, s
export const FmtInlineCode: FormattingFeature = "inline_code"; // code
export const FmtCodeBlock: FormattingFeature = "code_block"; // pre + code
export const FmtSyntaxHighlighting: FormattingFeature = "code_block.syntax_highlighting"; // <pre><code class="language-...">
export const FmtBlockquote: FormattingFeature = "blockquote"; // blockquote
export const FmtInlineLink: FormattingFeature = "inline_link"; // a
export const FmtUserLink: FormattingFeature = "user_link"; // <a href="https://matrix.to/#/@...">
export const FmtRoomLink: FormattingFeature = "room_link"; // <a href="https://matrix.to/#/#...">
export const FmtEventLink: FormattingFeature = "event_link"; // <a href="https://matrix.to/#/!.../$...">
export const FmtAtRoomMention: FormattingFeature = "at_room_mention"; // @room (no html tag)
export const FmtUnorderedList: FormattingFeature = "unordered_list"; // ul + li
export const FmtOrderedList: FormattingFeature = "ordered_list"; // ol + li
export const FmtListStart: FormattingFeature = "ordered_list.start"; // <ol start="N">
export const FmtListJumpValue: FormattingFeature = "ordered_list.jump_value"; // <li value="N">
export const FmtCustomEmoji: FormattingFeature = "custom_emoji"; // <img data-mx-emoticon>
export const FmtSpoiler: FormattingFeature = "spoiler"; // <span data-mx-spoiler>
export const FmtSpoilerReason: FormattingFeature = "spoiler.reason"; // <span data-mx-spoiler="...">
export const FmtTextForegroundColor: FormattingFeature = "color.foreground"; // <span data-mx-color="#...">
export const FmtTextBackgroundColor: FormattingFeature = "color.background"; // <span data-mx-bg-color="#...">
export const FmtHorizontalLine: FormattingFeature = "horizontal_line"; // hr
export const FmtHeaders: FormattingFeature = "headers"; // h1, h2, h3, h4, h5, h6
export const FmtSuperscript: FormattingFeature = "superscript"; // sup
export const FmtSubscript: FormattingFeature = "subscript"; // sub
export const FmtMath: FormattingFeature = "math"; // <span data-mx-maths="...">
export const FmtDetailsSummary: FormattingFeature = "details_summary"; // <details><summary>...</summary>...</details>
export const FmtTable: FormattingFeature = "table"; // table, thead, tbody, tr, th, td
export interface FileFeatures {
  mime_types: { [key: string]: CapabilitySupportLevel};
  caption?: CapabilitySupportLevel;
  max_caption_length?: number /* int */;
  max_size?: number /* int64 */;
  max_width?: number /* int */;
  max_height?: number /* int */;
  max_duration?: any /* jsontime.Seconds */;
  view_once?: boolean;
}

//////////
// source: content.go

/**
 * Content stores the content of a Matrix event.
 * By default, the raw JSON bytes are stored in VeryRaw and parsed into a map[string]interface{} in the Raw field.
 * Additionally, you can call ParseRaw with the correct event type to parse the (VeryRaw) content into a nicer struct,
 * which you can then access from Parsed or via the helper functions.
 * When being marshaled into JSON, the data in Parsed will be marshaled first and then recursively merged
 * with the data in Raw. Values in Raw are preferred, but nested objects will be recursed into before merging,
 * rather than overriding the whole object with the one in Raw).
 * If one of them is nil, the only the other is used. If both (Parsed and Raw) are nil, VeryRaw is used instead.
 */
export interface Content {
  VeryRaw: any /* json.RawMessage */;
  Raw: { [key: string]: any};
  Parsed: any;
}
export type Relatable = any;

//////////
// source: encryption.go

/**
 * EncryptionEventContent represents the content of a m.room.encryption state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomencryption
 */
export interface EncryptionEventContent {
  /**
   * The encryption algorithm to be used to encrypt messages sent in this room. Must be 'm.megolm.v1.aes-sha2'.
   */
  algorithm: any /* id.Algorithm */;
  /**
   * How long the session should be used before changing it. 604800000 (a week) is the recommended default.
   */
  rotation_period_ms?: number /* int64 */;
  /**
   * How many messages should be sent before changing the session. 100 is the recommended default.
   */
  rotation_period_msgs?: number /* int */;
}
/**
 * EncryptedEventContent represents the content of a m.room.encrypted message event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomencrypted
 * Note that sender_key and device_id are deprecated in Megolm events as of https://github.com/matrix-org/matrix-spec-proposals/pull/3700
 */
export interface EncryptedEventContent {
  algorithm: any /* id.Algorithm */;
  sender_key?: any /* id.SenderKey */;
  /**
   * Deprecated: Matrix v1.3
   */
  device_id?: MautrixID.DeviceID;
  /**
   * Only present for Megolm events
   */
  session_id?: any /* id.SessionID */;
  ciphertext: any /* json.RawMessage */;
  'm.relates_to'?: RelatesTo;
  'm.mentions'?: Mentions;
}
export type OlmCiphertexts = { [key: any /* id.Curve25519 */]: {
    body: string;
    type: any /* id.OlmMsgType */;
  }};
/**
 * RoomKeyEventContent represents the content of a m.room_key to_device event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroom_key
 */
export interface RoomKeyEventContent {
  algorithm: any /* id.Algorithm */;
  room_id: MautrixID.RoomID;
  session_id: any /* id.SessionID */;
  session_key: string;
  'com.beeper.max_age_ms': number /* int64 */;
  'com.beeper.max_messages': number /* int */;
  'com.beeper.is_scheduled': boolean;
}
/**
 * ForwardedRoomKeyEventContent represents the content of a m.forwarded_room_key to_device event.
 * https://spec.matrix.org/v1.2/client-server-api/#mforwarded_room_key
 */
export interface ForwardedRoomKeyEventContent {
  RoomKeyEventContent: RoomKeyEventContent;
  sender_key: any /* id.SenderKey */;
  sender_claimed_ed25519_key: any /* id.Ed25519 */;
  forwarding_curve25519_key_chain: string[];
  'com.beeper.max_age_ms': number /* int64 */;
  'com.beeper.max_messages': number /* int */;
  'com.beeper.is_scheduled': boolean;
}
export type KeyRequestAction = string;
export const KeyRequestActionRequest = "request";
export const KeyRequestActionCancel = "request_cancellation";
/**
 * RoomKeyRequestEventContent represents the content of a m.room_key_request to_device event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroom_key_request
 */
export interface RoomKeyRequestEventContent {
  body: RequestedKeyInfo;
  action: KeyRequestAction;
  requesting_device_id: MautrixID.DeviceID;
  request_id: string;
}
export interface RequestedKeyInfo {
  algorithm: any /* id.Algorithm */;
  room_id: MautrixID.RoomID;
  sender_key: any /* id.SenderKey */;
  session_id: any /* id.SessionID */;
}
export type RoomKeyWithheldCode = string;
export const RoomKeyWithheldBlacklisted: RoomKeyWithheldCode = "m.blacklisted";
export const RoomKeyWithheldUnverified: RoomKeyWithheldCode = "m.unverified";
export const RoomKeyWithheldUnauthorized: RoomKeyWithheldCode = "m.unauthorised";
export const RoomKeyWithheldUnavailable: RoomKeyWithheldCode = "m.unavailable";
export const RoomKeyWithheldNoOlmSession: RoomKeyWithheldCode = "m.no_olm";
export const RoomKeyWithheldBeeperRedacted: RoomKeyWithheldCode = "com.beeper.redacted";
export interface RoomKeyWithheldEventContent {
  room_id?: MautrixID.RoomID;
  algorithm: any /* id.Algorithm */;
  session_id?: any /* id.SessionID */;
  sender_key: any /* id.SenderKey */;
  code: RoomKeyWithheldCode;
  reason?: string;
}
export type SecretRequestAction = string;
export const SecretRequestRequest = "request";
export const SecretRequestCancellation = "request_cancellation";
export interface SecretRequestEventContent {
  name?: any /* id.Secret */;
  action: SecretRequestAction;
  requesting_device_id: MautrixID.DeviceID;
  request_id: string;
}
export interface SecretSendEventContent {
  request_id: string;
  secret: string;
}
export interface DummyEventContent {
}

//////////
// source: ephemeral.go

/**
 * TypingEventContent represents the content of a m.typing ephemeral event.
 * https://spec.matrix.org/v1.2/client-server-api/#mtyping
 */
export interface TypingEventContent {
  user_ids: MautrixID.UserID[];
}
/**
 * ReceiptEventContent represents the content of a m.receipt ephemeral event.
 * https://spec.matrix.org/v1.2/client-server-api/#mreceipt
 */
export type ReceiptEventContent = { [key: MautrixID.EventID]: Receipts};
export type ReceiptType = string;
export const ReceiptTypeRead: ReceiptType = "m.read";
export const ReceiptTypeReadPrivate: ReceiptType = "m.read.private";
export type Receipts = { [key: ReceiptType]: UserReceipts};
export type UserReceipts = { [key: MautrixID.UserID]: ReadReceipt};
export type ThreadID = MautrixID.EventID;
export const ReadReceiptThreadMain: ThreadID = "main";
export interface ReadReceipt {
  Timestamp: string /* RFC3339 */;
  /**
   * Thread ID for thread-specific read receipts from MSC3771
   */
  ThreadID: ThreadID;
  /**
   * Extra contains any unknown fields in the read receipt event.
   * Most servers don't allow clients to set them, so this will be empty in most cases.
   */
  Extra: { [key: string]: any};
}
export type Presence = string;
export const PresenceOnline: Presence = "online";
export const PresenceOffline: Presence = "offline";
export const PresenceUnavailable: Presence = "unavailable";
/**
 * PresenceEventContent represents the content of a m.presence ephemeral event.
 * https://spec.matrix.org/v1.2/client-server-api/#mpresence
 */
export interface PresenceEventContent {
  presence: Presence;
  displayname?: string;
  avatar_url?: MautrixID.ContentURIString;
  last_active_ago?: number /* int64 */;
  currently_active?: boolean;
  status_msg?: string;
}

//////////
// source: events.go

/**
 * Event represents a single Matrix event.
 */
export interface Event {
  state_key?: string; // The state key for the event. Only present on State Events.
  sender?: MautrixID.UserID; // The user ID of the sender of the event
  type: Type; // The event type
  origin_server_ts?: number /* int64 */; // The unix timestamp when this message was sent by the origin server
  event_id?: MautrixID.EventID; // The unique ID of this event
  room_id?: MautrixID.RoomID; // The room the event was sent to. May be nil (e.g. for presence)
  content: Content; // The JSON content of the event.
  redacts?: MautrixID.EventID; // The event ID that was redacted if a m.room.redaction event
  unsigned?: Unsigned; // Unsigned content set by own homeserver.
  to_user_id?: MautrixID.UserID; // The user ID that the to-device event was sent to. Only present in MSC2409 appservice transactions.
  to_device_id?: MautrixID.DeviceID; // The device ID that the to-device event was sent to. Only present in MSC2409 appservice transactions.
}
export interface MautrixInfo {
  EventSource: Source;
  TrustState: any /* id.TrustState */;
  ForwardedKeys: boolean;
  WasEncrypted: boolean;
  TrustSource?: any /* id.Device */;
  ReceivedAt: string /* RFC3339 */;
  EditedAt: string /* RFC3339 */;
  LastEditID: MautrixID.EventID;
  DecryptionDuration: any /* time.Duration */;
  CheckpointSent: boolean;
  /**
   * When using MSC4222 and the state_after field, this field is set
   * for timeline events to indicate they shouldn't update room state.
   */
  IgnoreState: boolean;
}
export interface StrippedState {
  content: Content;
  type: Type;
  state_key: string;
  sender: MautrixID.UserID;
}
export interface Unsigned {
  prev_content?: Content;
  prev_sender?: MautrixID.UserID;
  replaces_state?: MautrixID.EventID;
  age?: number /* int64 */;
  transaction_id?: string;
  'm.relations'?: Relations;
  redacted_because?: Event;
  invite_room_state?: StrippedState[];
  'com.beeper.hs.order'?: number /* int64 */;
  'com.beeper.hs.suborder'?: number /* int16 */;
  'com.beeper.hs.order_string'?: BeeperEncodedOrder;
  'com.beeper.from_backup'?: boolean;
}

//////////
// source: eventsource.go

/**
 * Source represents the part of the sync response that an event came from.
 */
export type Source = number /* int */;
export const SourcePresence: Source = 1 << 0;
export const SourceJoin: Source = 1 << 1;
export const SourceInvite: Source = 1 << 2;
export const SourceLeave: Source = 1 << 3;
export const SourceAccountData: Source = 1 << 4;
export const SourceTimeline: Source = 1 << 5;
export const SourceState: Source = 1 << 6;
export const SourceEphemeral: Source = 1 << 7;
export const SourceToDevice: Source = 1 << 8;
export const SourceDecrypted: Source = 1 << 9;

//////////
// source: member.go

/**
 * Membership is an enum specifying the membership state of a room member.
 */
export type Membership = string;
/**
 * The allowed membership states as specified in spec section 10.5.5.
 */
export const MembershipJoin: Membership = "join";
/**
 * The allowed membership states as specified in spec section 10.5.5.
 */
export const MembershipLeave: Membership = "leave";
/**
 * The allowed membership states as specified in spec section 10.5.5.
 */
export const MembershipInvite: Membership = "invite";
/**
 * The allowed membership states as specified in spec section 10.5.5.
 */
export const MembershipBan: Membership = "ban";
/**
 * The allowed membership states as specified in spec section 10.5.5.
 */
export const MembershipKnock: Membership = "knock";
/**
 * MemberEventContent represents the content of a m.room.member state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroommember
 */
export interface MemberEventContent {
  membership: Membership;
  avatar_url?: MautrixID.ContentURIString;
  displayname?: string;
  is_direct?: boolean;
  third_party_invite?: ThirdPartyInvite;
  reason?: string;
  'org.matrix.msc3414.file'?: EncryptedFileInfo;
}
export interface ThirdPartyInvite {
  display_name: string;
  Signed: {
    token: string;
    signatures: any /* json.RawMessage */;
    mxid: string;
  };
}

//////////
// source: message.go

/**
 * MessageType is the sub-type of a m.room.message event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroommessage-msgtypes
 */
export type MessageType = string;
/**
 * Msgtypes
 */
export const MsgText: MessageType = "m.text";
/**
 * Msgtypes
 */
export const MsgEmote: MessageType = "m.emote";
/**
 * Msgtypes
 */
export const MsgNotice: MessageType = "m.notice";
/**
 * Msgtypes
 */
export const MsgImage: MessageType = "m.image";
/**
 * Msgtypes
 */
export const MsgLocation: MessageType = "m.location";
/**
 * Msgtypes
 */
export const MsgVideo: MessageType = "m.video";
/**
 * Msgtypes
 */
export const MsgAudio: MessageType = "m.audio";
/**
 * Msgtypes
 */
export const MsgFile: MessageType = "m.file";
/**
 * Msgtypes
 */
export const MsgVerificationRequest: MessageType = "m.key.verification.request";
/**
 * Msgtypes
 */
export const MsgBeeperGallery: MessageType = "com.beeper.gallery";
/**
 * Format specifies the format of the formatted_body in m.room.message events.
 * https://spec.matrix.org/v1.2/client-server-api/#mroommessage-msgtypes
 */
export type Format = string;
/**
 * Message formats
 */
export const FormatHTML: Format = "org.matrix.custom.html";
/**
 * RedactionEventContent represents the content of a m.room.redaction message event.
 * https://spec.matrix.org/v1.8/client-server-api/#mroomredaction
 */
export interface RedactionEventContent {
  reason?: string;
  /**
   * The event ID is here as of room v11. In old servers it may only be at the top level.
   */
  redacts?: MautrixID.EventID;
}
/**
 * ReactionEventContent represents the content of a m.reaction message event.
 * This is not yet in a spec release, see https://github.com/matrix-org/matrix-doc/pull/1849
 */
export interface ReactionEventContent {
  'm.relates_to': RelatesTo;
}
/**
 * MessageEventContent represents the content of a m.room.message event.
 * It is also used to represent m.sticker events, as they are equivalent to m.room.message
 * with the exception of the msgtype field.
 * https://spec.matrix.org/v1.2/client-server-api/#mroommessage
 */
export interface MessageEventContent {
  /**
   * Base m.room.message fields
   */
  msgtype?: MessageType;
  body: string;
  /**
   * Extra fields for text types
   */
  format?: Format;
  formatted_body?: string;
  /**
   * Extra field for m.location
   */
  geo_uri?: string;
  /**
   * Extra fields for media types
   */
  url?: MautrixID.ContentURIString;
  info?: FileInfo;
  file?: EncryptedFileInfo;
  filename?: string;
  'm.mentions'?: Mentions;
  /**
   * Edits and relations
   */
  'm.new_content'?: MessageEventContent;
  'm.relates_to'?: RelatesTo;
  /**
   * In-room verification
   */
  to?: MautrixID.UserID;
  from_device?: MautrixID.DeviceID;
  methods?: VerificationMethod[];
  'com.beeper.message_send_retry'?: BeeperRetryMetadata;
  'com.beeper.gallery.images'?: (MessageEventContent | undefined)[];
  'com.beeper.gallery.caption'?: string;
  'com.beeper.gallery.caption_html'?: string;
  'com.beeper.per_message_profile'?: BeeperPerMessageProfile;
  'com.beeper.linkpreviews'?: (BeeperLinkPreview | undefined)[];
  'org.matrix.msc1767.audio'?: MSC1767Audio;
  'org.matrix.msc3245.voice'?: MSC3245Voice;
}
export interface Mentions {
  user_ids?: MautrixID.UserID[];
  room?: boolean;
}
export interface EncryptedFileInfo {
  EncryptedFile: any /* attachment.EncryptedFile */;
  url: MautrixID.ContentURIString;
}
export interface FileInfo {
  MimeType: string;
  ThumbnailInfo?: FileInfo;
  ThumbnailURL: MautrixID.ContentURIString;
  ThumbnailFile?: EncryptedFileInfo;
  Blurhash: string;
  AnoaBlurhash: string;
  MauGIF: boolean;
  Width: number /* int */;
  Height: number /* int */;
  Duration: number /* int */;
  Size: number /* int */;
}

//////////
// source: poll.go

export interface PollResponseEventContent {
  'm.relates_to': RelatesTo;
  'org.matrix.msc3381.poll.response': {
    answers: string[];
  };
}
export interface MSC1767Message {
  'org.matrix.msc1767.text'?: string;
  'org.matrix.msc1767.html'?: string;
  'org.matrix.msc1767.message'?: ExtensibleText[];
}
export interface PollStartEventContent {
  'm.relates_to'?: RelatesTo;
  'm.mentions'?: Mentions;
  'org.matrix.msc3381.poll.start': {
    kind: string;
    max_selections: number /* int */;
    question: MSC1767Message;
    answers: {
      id: string;
      MSC1767Message: MSC1767Message;
    }[];
  };
}

//////////
// source: powerlevels.go

/**
 * PowerLevelsEventContent represents the content of a m.room.power_levels state event content.
 * https://spec.matrix.org/v1.5/client-server-api/#mroompower_levels
 */
export interface PowerLevelsEventContent {
  users?: { [key: MautrixID.UserID]: number /* int */};
  users_default?: number /* int */;
  events?: { [key: string]: number /* int */};
  events_default?: number /* int */;
  notifications?: NotificationPowerLevels;
  state_default?: number /* int */;
  invite?: number /* int */;
  kick?: number /* int */;
  ban?: number /* int */;
  redact?: number /* int */;
}
export interface NotificationPowerLevels {
  room?: number /* int */;
}

//////////
// source: relations.go

export type RelationType = string;
export const RelReplace: RelationType = "m.replace";
export const RelReference: RelationType = "m.reference";
export const RelAnnotation: RelationType = "m.annotation";
export const RelThread: RelationType = "m.thread";
export const RelBeeperTranscription: RelationType = "com.beeper.transcription";
export interface RelatesTo {
  rel_type?: RelationType;
  event_id?: MautrixID.EventID;
  key?: string;
  'm.in_reply_to'?: InReplyTo;
  is_falling_back?: boolean;
}
export interface InReplyTo {
  event_id?: MautrixID.EventID;
  room_id?: MautrixID.RoomID;
}
export interface RelationChunkItem {
  type: RelationType;
  event_id?: string;
  key?: string;
  count?: number /* int */;
}
export interface RelationChunk {
  chunk: RelationChunkItem[];
  limited: boolean;
  count: number /* int */;
}
export interface AnnotationChunk {
  RelationChunk: RelationChunk;
}
export interface EventIDChunk {
  RelationChunk: RelationChunk;
}
export interface Relations {
  'm.annotation'?: AnnotationChunk;
  'm.reference'?: EventIDChunk;
  'm.replace'?: EventIDChunk;
}

//////////
// source: state.go

/**
 * CanonicalAliasEventContent represents the content of a m.room.canonical_alias state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomcanonical_alias
 */
export interface CanonicalAliasEventContent {
  alias: any /* id.RoomAlias */;
  alt_aliases?: any /* id.RoomAlias */[];
}
/**
 * RoomNameEventContent represents the content of a m.room.name state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomname
 */
export interface RoomNameEventContent {
  name: string;
}
/**
 * RoomAvatarEventContent represents the content of a m.room.avatar state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomavatar
 */
export interface RoomAvatarEventContent {
  url?: MautrixID.ContentURIString;
  info?: FileInfo;
  'org.matrix.msc3414.file'?: EncryptedFileInfo;
}
/**
 * ServerACLEventContent represents the content of a m.room.server_acl state event.
 * https://spec.matrix.org/v1.2/client-server-api/#server-access-control-lists-acls-for-rooms
 */
export interface ServerACLEventContent {
  allow?: string[];
  allow_ip_literals: boolean;
  deny?: string[];
}
/**
 * TopicEventContent represents the content of a m.room.topic state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomtopic
 */
export interface TopicEventContent {
  topic: string;
  'm.topic'?: ExtensibleTopic;
}
/**
 * ExtensibleTopic represents the contents of the m.topic field within the
 * m.room.topic state event as described in [MSC3765].
 * [MSC3765]: https://github.com/matrix-org/matrix-spec-proposals/pull/3765
 */
export interface ExtensibleTopic {
  'm.text': ExtensibleText[];
}
/**
 * ExtensibleText represents the contents of an m.text field.
 */
export interface ExtensibleText {
  mimetype?: string;
  body: string;
}
/**
 * TombstoneEventContent represents the content of a m.room.tombstone state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomtombstone
 */
export interface TombstoneEventContent {
  body: string;
  replacement_room: MautrixID.RoomID;
}
export interface Predecessor {
  room_id: MautrixID.RoomID;
  event_id: MautrixID.EventID;
}
export type RoomVersion = string;
export const RoomV1: RoomVersion = "1";
export const RoomV2: RoomVersion = "2";
export const RoomV3: RoomVersion = "3";
export const RoomV4: RoomVersion = "4";
export const RoomV5: RoomVersion = "5";
export const RoomV6: RoomVersion = "6";
export const RoomV7: RoomVersion = "7";
export const RoomV8: RoomVersion = "8";
export const RoomV9: RoomVersion = "9";
export const RoomV10: RoomVersion = "10";
export const RoomV11: RoomVersion = "11";
/**
 * CreateEventContent represents the content of a m.room.create state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomcreate
 */
export interface CreateEventContent {
  type?: RoomType;
  'm.federate'?: boolean;
  room_version?: RoomVersion;
  predecessor?: Predecessor;
  /**
   * Deprecated: use the event sender instead
   */
  creator?: MautrixID.UserID;
}
/**
 * JoinRule specifies how open a room is to new members.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomjoin_rules
 */
export type JoinRule = string;
export const JoinRulePublic: JoinRule = "public";
export const JoinRuleKnock: JoinRule = "knock";
export const JoinRuleInvite: JoinRule = "invite";
export const JoinRuleRestricted: JoinRule = "restricted";
export const JoinRuleKnockRestricted: JoinRule = "knock_restricted";
export const JoinRulePrivate: JoinRule = "private";
/**
 * JoinRulesEventContent represents the content of a m.room.join_rules state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomjoin_rules
 */
export interface JoinRulesEventContent {
  join_rule: JoinRule;
  allow?: JoinRuleAllow[];
}
export type JoinRuleAllowType = string;
export const JoinRuleAllowRoomMembership: JoinRuleAllowType = "m.room_membership";
export interface JoinRuleAllow {
  room_id: MautrixID.RoomID;
  type: JoinRuleAllowType;
}
/**
 * PinnedEventsEventContent represents the content of a m.room.pinned_events state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroompinned_events
 */
export interface PinnedEventsEventContent {
  pinned: MautrixID.EventID[];
}
/**
 * HistoryVisibility specifies who can see new messages.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomhistory_visibility
 */
export type HistoryVisibility = string;
export const HistoryVisibilityInvited: HistoryVisibility = "invited";
export const HistoryVisibilityJoined: HistoryVisibility = "joined";
export const HistoryVisibilityShared: HistoryVisibility = "shared";
export const HistoryVisibilityWorldReadable: HistoryVisibility = "world_readable";
/**
 * HistoryVisibilityEventContent represents the content of a m.room.history_visibility state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomhistory_visibility
 */
export interface HistoryVisibilityEventContent {
  history_visibility: HistoryVisibility;
}
/**
 * GuestAccess specifies whether or not guest accounts can join.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomguest_access
 */
export type GuestAccess = string;
export const GuestAccessCanJoin: GuestAccess = "can_join";
export const GuestAccessForbidden: GuestAccess = "forbidden";
/**
 * GuestAccessEventContent represents the content of a m.room.guest_access state event.
 * https://spec.matrix.org/v1.2/client-server-api/#mroomguest_access
 */
export interface GuestAccessEventContent {
  guest_access: GuestAccess;
}
export interface BridgeInfoSection {
  id: string;
  displayname?: string;
  avatar_url?: MautrixID.ContentURIString;
  external_url?: string;
  'fi.mau.receiver'?: string;
}
/**
 * BridgeEventContent represents the content of a m.bridge state event.
 * https://github.com/matrix-org/matrix-doc/pull/2346
 */
export interface BridgeEventContent {
  bridgebot: MautrixID.UserID;
  creator?: MautrixID.UserID;
  protocol: BridgeInfoSection;
  network?: BridgeInfoSection;
  channel: BridgeInfoSection;
  'com.beeper.room_type'?: string;
  'com.beeper.room_type.v2'?: string;
}
export interface SpaceChildEventContent {
  via?: string[];
  order?: string;
  suggested?: boolean;
}
export interface SpaceParentEventContent {
  via?: string[];
  canonical?: boolean;
}
export type PolicyRecommendation = string;
export const PolicyRecommendationBan: PolicyRecommendation = "m.ban";
export const PolicyRecommendationUnstableTakedown: PolicyRecommendation = "org.matrix.msc4204.takedown";
export const PolicyRecommendationUnstableBan: PolicyRecommendation = "org.matrix.mjolnir.ban";
export const PolicyRecommendationUnban: PolicyRecommendation = "fi.mau.meowlnir.unban";
export interface PolicyHashes {
  sha256: string;
}
/**
 * ModPolicyContent represents the content of a m.room.rule.user, m.room.rule.room, and m.room.rule.server state event.
 * https://spec.matrix.org/v1.2/client-server-api/#moderation-policy-lists
 */
export interface ModPolicyContent {
  entity: string;
  reason: string;
  recommendation: PolicyRecommendation;
  'org.matrix.msc4205.hashes'?: PolicyHashes;
}
/**
 * Deprecated: MSC2716 has been abandoned
 */
export interface InsertionMarkerContent {
  'org.matrix.msc2716.marker.insertion': MautrixID.EventID;
  'com.beeper.timestamp'?: number /* int64 */;
}
export interface ElementFunctionalMembersContent {
  service_members: MautrixID.UserID[];
}

//////////
// source: type.go

export type RoomType = string;
export const RoomTypeDefault: RoomType = "";
export const RoomTypeSpace: RoomType = "m.space";
export type TypeClass = number /* int */;
/**
 * Unknown events
 */
export const UnknownEventType: TypeClass = 0;
/**
 * Normal message events
 */
export const MessageEventType: TypeClass = 1;
/**
 * State events
 */
export const StateEventType: TypeClass = 2;
/**
 * Ephemeral events
 */
export const EphemeralEventType: TypeClass = 3;
/**
 * Account data events
 */
export const AccountDataEventType: TypeClass = 4;
/**
 * Device-to-device events
 */
export const ToDeviceEventType: TypeClass = 5;
export interface Type {
  Type: string;
  Class: TypeClass;
}

//////////
// source: verification.go

export type VerificationMethod = string;
export const VerificationMethodSAS: VerificationMethod = "m.sas.v1";
export const VerificationMethodReciprocate: VerificationMethod = "m.reciprocate.v1";
export const VerificationMethodQRCodeShow: VerificationMethod = "m.qr_code.show.v1";
export const VerificationMethodQRCodeScan: VerificationMethod = "m.qr_code.scan.v1";
export type VerificationTransactionable = any;
/**
 * ToDeviceVerificationEvent contains the fields common to all to-device
 * verification events.
 */
export interface ToDeviceVerificationEvent {
  /**
   * TransactionID is an opaque identifier for the verification request. Must
   * be unique with respect to the devices involved.
   */
  transaction_id?: any /* id.VerificationTransactionID */;
}
/**
 * InRoomVerificationEvent contains the fields common to all in-room
 * verification events.
 */
export interface InRoomVerificationEvent {
  /**
   * RelatesTo indicates the m.key.verification.request that this message is
   * related to. Note that for encrypted messages, this property should be in
   * the unencrypted portion of the event.
   */
  'm.relates_to'?: RelatesTo;
}
/**
 * VerificationRequestEventContent represents the content of an
 * [m.key.verification.request] to-device event as described in [Section
 * 11.12.2.1] of the Spec.
 * For the in-room version, use a standard [MessageEventContent] struct.
 * [m.key.verification.request]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationrequest
 * [Section 11.12.2.1]: https://spec.matrix.org/v1.9/client-server-api/#key-verification-framework
 */
export interface VerificationRequestEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  /**
   * FromDevice is the device ID which is initiating the request.
   */
  from_device: MautrixID.DeviceID;
  /**
   * Methods is a list of the verification methods supported by the sender.
   */
  methods: VerificationMethod[];
  /**
   * Timestamp is the time at which the request was made.
   */
  timestamp?: any /* jsontime.UnixMilli */;
}
/**
 * VerificationReadyEventContent represents the content of an
 * [m.key.verification.ready] event (both the to-device and the in-room
 * version) as described in [Section 11.12.2.1] of the Spec.
 * [m.key.verification.ready]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationready
 * [Section 11.12.2.1]: https://spec.matrix.org/v1.9/client-server-api/#key-verification-framework
 */
export interface VerificationReadyEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * FromDevice is the device ID which is initiating the request.
   */
  from_device: MautrixID.DeviceID;
  /**
   * Methods is a list of the verification methods supported by the sender.
   */
  methods: VerificationMethod[];
}
export type KeyAgreementProtocol = string;
export const KeyAgreementProtocolCurve25519: KeyAgreementProtocol = "curve25519";
export const KeyAgreementProtocolCurve25519HKDFSHA256: KeyAgreementProtocol = "curve25519-hkdf-sha256";
export type VerificationHashMethod = string;
export const VerificationHashMethodSHA256: VerificationHashMethod = "sha256";
export type MACMethod = string;
export const MACMethodHKDFHMACSHA256: MACMethod = "hkdf-hmac-sha256";
export const MACMethodHKDFHMACSHA256V2: MACMethod = "hkdf-hmac-sha256.v2";
export type SASMethod = string;
export const SASMethodDecimal: SASMethod = "decimal";
export const SASMethodEmoji: SASMethod = "emoji";
/**
 * VerificationStartEventContent represents the content of an
 * [m.key.verification.start] event (both the to-device and the in-room
 * version) as described in [Section 11.12.2.1] of the Spec.
 * This struct also contains the fields for an [m.key.verification.start] event
 * using the [VerificationMethodSAS] method as described in [Section
 * 11.12.2.2.2] and an [m.key.verification.start] using
 * [VerificationMethodReciprocate] as described in [Section 11.12.2.4.2].
 * [m.key.verification.start]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationstart
 * [Section 11.12.2.1]: https://spec.matrix.org/v1.9/client-server-api/#key-verification-framework
 * [Section 11.12.2.2.2]: https://spec.matrix.org/v1.9/client-server-api/#verification-messages-specific-to-sas
 * [Section 11.12.2.4.2]: https://spec.matrix.org/v1.9/client-server-api/#verification-messages-specific-to-qr-codes
 */
export interface VerificationStartEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * FromDevice is the device ID which is initiating the request.
   */
  from_device: MautrixID.DeviceID;
  /**
   * Method is the verification method to use.
   */
  method: VerificationMethod;
  /**
   * NextMethod is an optional method to use to verify the other user's key.
   * Applicable when the method chosen only verifies one user’s key. This
   * field will never be present if the method verifies keys both ways.
   */
  next_method?: VerificationMethod;
  /**
   * Hashes are the hash methods the sending device understands. This field
   * is only applicable when the method is m.sas.v1.
   */
  hashes?: VerificationHashMethod[];
  /**
   * KeyAgreementProtocols is the list of key agreement protocols the sending
   * device understands. This field is only applicable when the method is
   * m.sas.v1.
   */
  key_agreement_protocols?: KeyAgreementProtocol[];
  /**
   * MessageAuthenticationCodes is a list of the MAC methods that the sending
   * device understands. This field is only applicable when the method is
   * m.sas.v1.
   */
  message_authentication_codes: MACMethod[];
  /**
   * ShortAuthenticationString is a list of SAS methods the sending device
   * (and the sending device's user) understands. This field is only
   * applicable when the method is m.sas.v1.
   */
  short_authentication_string: SASMethod[];
  /**
   * Secret is the shared secret from the QR code. This field is only
   * applicable when the method is m.reciprocate.v1.
   */
  secret?: any /* jsonbytes.UnpaddedBytes */;
}
/**
 * VerificationDoneEventContent represents the content of an
 * [m.key.verification.done] event (both the to-device and the in-room version)
 * as described in [Section 11.12.2.1] of the Spec.
 * This type is an alias for [VerificationRelatable] since there are no
 * additional fields defined by the spec.
 * [m.key.verification.done]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationdone
 * [Section 11.12.2.1]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationdone
 */
export interface VerificationDoneEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
}
export type VerificationCancelCode = string;
export const VerificationCancelCodeUser: VerificationCancelCode = "m.user";
export const VerificationCancelCodeTimeout: VerificationCancelCode = "m.timeout";
export const VerificationCancelCodeUnknownTransaction: VerificationCancelCode = "m.unknown_transaction";
export const VerificationCancelCodeUnknownMethod: VerificationCancelCode = "m.unknown_method";
export const VerificationCancelCodeUnexpectedMessage: VerificationCancelCode = "m.unexpected_message";
export const VerificationCancelCodeKeyMismatch: VerificationCancelCode = "m.key_mismatch";
export const VerificationCancelCodeUserMismatch: VerificationCancelCode = "m.user_mismatch";
export const VerificationCancelCodeInvalidMessage: VerificationCancelCode = "m.invalid_message";
export const VerificationCancelCodeAccepted: VerificationCancelCode = "m.accepted";
export const VerificationCancelCodeSASMismatch: VerificationCancelCode = "m.mismatched_sas";
export const VerificationCancelCodeCommitmentMismatch: VerificationCancelCode = "m.mismatched_commitment";
/**
 * Non-spec codes
 */
export const VerificationCancelCodeInternalError: VerificationCancelCode = "com.beeper.internal_error";
export const VerificationCancelCodeMasterKeyNotTrusted: VerificationCancelCode = "com.beeper.master_key_not_trusted"; // the master key is not trusted by this device, but the QR code that was scanned was from a device that doesn't trust the master key
/**
 * VerificationCancelEventContent represents the content of an
 * [m.key.verification.cancel] event (both the to-device and the in-room
 * version) as described in [Section 11.12.2.1] of the Spec.
 * [m.key.verification.cancel]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationcancel
 * [Section 11.12.2.1]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationdone
 */
export interface VerificationCancelEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * Code is the error code for why the process/request was cancelled by the
   * user.
   */
  code: VerificationCancelCode;
  /**
   * Reason is a human readable description of the code. The client should
   * only rely on this string if it does not understand the code.
   */
  reason: string;
}
/**
 * VerificationAcceptEventContent represents the content of an
 * [m.key.verification.accept] event (both the to-device and the in-room
 * version) as described in [Section 11.12.2.2.2] of the Spec.
 * [m.key.verification.accept]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationaccept
 * [Section 11.12.2.2.2]: https://spec.matrix.org/v1.9/client-server-api/#verification-messages-specific-to-sas
 */
export interface VerificationAcceptEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * Commitment is the hash of the concatenation of the device's ephemeral
   * public key (encoded as unpadded base64) and the canonical JSON
   * representation of the m.key.verification.start message.
   */
  commitment: any /* jsonbytes.UnpaddedBytes */;
  /**
   * Hash is the hash method the device is choosing to use, out of the
   * options in the m.key.verification.start message.
   */
  hash: VerificationHashMethod;
  /**
   * KeyAgreementProtocol is the key agreement protocol the device is
   * choosing to use, out of the options in the m.key.verification.start
   * message.
   */
  key_agreement_protocol: KeyAgreementProtocol;
  /**
   * MessageAuthenticationCode is the message authentication code the device
   * is choosing to use, out of the options in the m.key.verification.start
   * message.
   */
  message_authentication_code: MACMethod;
  /**
   * ShortAuthenticationString is a list of SAS methods both devices involved
   * in the verification process understand. Must be a subset of the options
   * in the m.key.verification.start message.
   */
  short_authentication_string: SASMethod[];
}
/**
 * VerificationKeyEventContent represents the content of an
 * [m.key.verification.key] event (both the to-device and the in-room version)
 * as described in [Section 11.12.2.2.2] of the Spec.
 * [m.key.verification.key]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationkey
 * [Section 11.12.2.2.2]: https://spec.matrix.org/v1.9/client-server-api/#verification-messages-specific-to-sas
 */
export interface VerificationKeyEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * Key is the device’s ephemeral public key.
   */
  key: any /* jsonbytes.UnpaddedBytes */;
}
/**
 * VerificationMACEventContent represents the content of an
 * [m.key.verification.mac] event (both the to-device and the in-room version)
 * as described in [Section 11.12.2.2.2] of the Spec.
 * [m.key.verification.mac]: https://spec.matrix.org/v1.9/client-server-api/#mkeyverificationmac
 * [Section 11.12.2.2.2]: https://spec.matrix.org/v1.9/client-server-api/#verification-messages-specific-to-sas
 */
export interface VerificationMACEventContent {
  ToDeviceVerificationEvent: ToDeviceVerificationEvent;
  InRoomVerificationEvent: InRoomVerificationEvent;
  /**
   * Keys is the MAC of the comma-separated, sorted, list of key IDs given in
   * the MAC property.
   */
  keys: any /* jsonbytes.UnpaddedBytes */;
  /**
   * MAC is a map of the key ID to the MAC of the key, using the algorithm in
   * the verification process.
   */
  mac: { [key: any /* id.KeyID */]: any /* jsonbytes.UnpaddedBytes */};
}

//////////
// source: voip.go

export type CallHangupReason = string;
export const CallHangupICEFailed: CallHangupReason = "ice_failed";
export const CallHangupInviteTimeout: CallHangupReason = "invite_timeout";
export const CallHangupUserHangup: CallHangupReason = "user_hangup";
export const CallHangupUserMediaFailed: CallHangupReason = "user_media_failed";
export const CallHangupUnknownError: CallHangupReason = "unknown_error";
export type CallDataType = string;
export const CallDataTypeOffer: CallDataType = "offer";
export const CallDataTypeAnswer: CallDataType = "answer";
export interface CallData {
  sdp: string;
  type: CallDataType;
}
export interface CallCandidate {
  candidate: string;
  sdpMLineIndex: number /* int */;
  sdpMid: string;
}
export type CallVersion = string;
export interface BaseCallEventContent {
  call_id: string;
  party_id: string;
  version: CallVersion;
}
export interface CallInviteEventContent {
  BaseCallEventContent: BaseCallEventContent;
  lifetime: number /* int */;
  offer: CallData;
}
export interface CallCandidatesEventContent {
  BaseCallEventContent: BaseCallEventContent;
  candidates: CallCandidate[];
}
export interface CallRejectEventContent {
  BaseCallEventContent: BaseCallEventContent;
}
export interface CallAnswerEventContent {
  BaseCallEventContent: BaseCallEventContent;
  answer: CallData;
}
export interface CallSelectAnswerEventContent {
  BaseCallEventContent: BaseCallEventContent;
  selected_party_id: string;
}
export interface CallNegotiateEventContent {
  BaseCallEventContent: BaseCallEventContent;
  lifetime: number /* int */;
  description: CallData;
}
export interface CallHangupEventContent {
  BaseCallEventContent: BaseCallEventContent;
  reason: CallHangupReason;
}
